@echo off
set prob=brackets
set model=md

echo [)())(]()]> 01
echo []> 02
echo [)(][]> 03
echo ())>04

echo (> 05
echo )> 06
echo ]> 07
echo [> 08
echo ()> 09

for /L %%i in (10,1,50) do if exist do%%i.dpr (
  dcc32 -cc do%%i.dpr > nul
  do%%i.exe > %%i
  del do%%i.exe > nul
)

copy ..\%prob%_%model%.dpr %prob%_%model%.dpr > nul
dcc32 -cc %prob%_%model%.dpr > nul
for %%i in (??) do (
  copy %%i %prob%.in > nul
  %prob%_%model%.exe
  copy %prob%.out %%i.a > nul
)
del %prob%.in
del %prob%.out
del %prob%_%model%.dpr
del %prob%_%model%.exe

copy ..\check.dpr check.dpr > nul
dcc32 -cc check.dpr > nul

rem REMOVE THE FOLLOWING LINE IF NEEDED
goto notesting

if not exist testlib.pas copy ..\testlib.pas testlib.pas
if not exist testlib.pas (
  echo ERROR: Can't test solutions: no testlib.pas found
  goto notesting
)

set tested=ia
echo ----- TESTING %tested% -----
copy ..\%prob%_%tested%.dpr %prob%_%tested%.dpr > nul
dcc32 -cc %prob%_%tested%.dpr > nul
for %%i in (??) do (
  copy %%i %prob%.in > nul
  %prob%_%tested%.exe
  check %%i %prob%.out %%i.a
)
del %prob%.in
del %prob%.out
del %prob%_%tested%.dpr
del %prob%_%tested%.exe

set tested=rs
echo ----- TESTING %tested% -----
copy ..\%prob%_%tested%.dpr %prob%_%tested%.dpr > nul
dcc32 -cc %prob%_%tested%.dpr > nul
for %%i in (??) do (
  copy %%i %prob%.in > nul
  %prob%_%tested%.exe
  check %%i %prob%.out %%i.a
)
del %prob%.in
del %prob%.out
del %prob%_%tested%.dpr
del %prob%_%tested%.exe

set tested=rs_bad
echo ----- TESTING %tested% -----
copy ..\%prob%_%tested%.dpr %prob%_%tested%.dpr > nul
dcc32 -cc %prob%_%tested%.dpr > nul
for %%i in (??) do (
  copy %%i %prob%.in > nul
  %prob%_%tested%.exe
  check %%i %prob%.out %%i.a
)
del %prob%.in
del %prob%.out
del %prob%_%tested%.dpr
del %prob%_%tested%.exe

set tested=md_bad
echo ----- TESTING %tested% -----
copy ..\%prob%_%tested%.dpr %prob%_%tested%.dpr > nul
dcc32 -cc %prob%_%tested%.dpr > nul
for %%i in (??) do (
  copy %%i %prob%.in > nul
  %prob%_%tested%.exe
  check %%i %prob%.out %%i.a
)
del %prob%.in
del %prob%.out
del %prob%_%tested%.dpr
del %prob%_%tested%.exe

set tested=dp
echo ----- TESTING %tested% -----
copy ..\%prob%_%tested%.java %prob%_%tested%.java > nul
javac %prob%_%tested%.java > nul
for %%i in (??) do (
  copy %%i %prob%.in > nul
  java %prob%_%tested%
  check %%i %prob%.out %%i.a
)
del %prob%.in
del %prob%.out
del %prob%_%tested%.java
del %prob%_%tested%.class

:notesting

del check.dpr
del check.exe
